Attribute VB_Name = "AddInConst"
Option Explicit

'Public Const TOOLBAR_NAME = "Addin SDK"

'Public Const CmdId_Button1 = 1
'Public Const CmdId_Button2 = 2
'Public Const CmdId_Button3 = 3

'Public Const Number_Of_Buttons = 3



''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''
''''''''''''''''''''''''''''''''''''''''''''''


'Invoke explorer over the specified file path (it opens the folder highlighting the file)
Public Sub OpenFolderWithFileSelection(ByVal sFile As String)
    Dim d As Double
    On Error Resume Next
    d = Shell("Explorer.exe /select," & Chr(34) & sFile & Chr(34), vbNormalFocus)
End Sub


'Get the full file name from the document if exist
Public Function GetSafeDocName(theDocument As Object) As String
    If theDocument Is Nothing Then
        GetSafeDocName = "(Nothing)"
    Else
        GetSafeDocName = theDocument.FullName
    End If
End Function

'Check if an item is present in a collection without raising any error
Public Function IsInCollection(coll As Collection, ByVal Key As Variant) As Boolean
    On Error Resume Next
    Call coll.Item(Key)
    If Err Then
        Err.Clear
        Exit Function
    End If
    IsInCollection = True
End Function

'ClipZero - Make sure the value is clipped for avoid problem while resizing forms
Public Function CZ(ByVal l As Long, Optional lClipVal As Long = 0) As Long
    CZ = IIf(l > lClipVal, l, lClipVal)
End Function

'GLOBAL ERROR HANDLER WITH DISPLAY OF CALL STACK UNROLLING
Public Sub ErrHandler(Optional module As String = "")
    Dim sErr As String, sMsg As String
    If module = "" Then module = "(Unknown)"
    sErr = Err.Description
    'If the error do not spawn on more lines add the error number
    If InStr(1, sErr, vbCrLf) = 0 Then
        sErr = "(" & Err.Number & ") - " & Err.Description
    End If
    sMsg = _
        "An unexpected error condition occurred." & vbCrLf & vbCrLf & _
        "Module: " & module & vbTab & " Code Line: " & Erl & vbCrLf & vbCrLf & _
        "---- Detail critical event ------------------------------------------" & vbCrLf & _
        sErr & vbCrLf
    DBG sMsg
    MsgBox sMsg, vbCritical
End Sub

'GLOBAL ERROR HANDLER WITH SUPPORT FOR CALL STACK UNROLLING
Public Sub ErrHandlerRaise(Optional module As String = "")
    Dim sErr As String, sMsg As String
    If module = "" Then module = "(Unknown)"
    sErr = Err.Description
    'Error Forwarding
    If Left(sErr, 5) = "Modul" Or InStr(1, sErr, vbCrLf) > 0 Then
        sMsg = "Module/LN: " & module & "/" & Erl & " - (error stack trace)" & vbCrLf & sErr
        Err.Raise Err.Number, module, sMsg
    Else
        sMsg = "Module/LN: " & module & "/" & Erl & " - " & sErr
        Err.Raise Err.Number, module, sMsg
    End If
End Sub

'Return a string from a variant without raising errors
Public Function CSafeStr(v As Variant) As String
    On Error Resume Next
    If IsNull(v) Or IsMissing(v) Or IsEmpty(v) Then Exit Function
    CSafeStr = Trim(CStr(v))
End Function


